## ros-lunar-rc-genicam-api 2.1.0

=== baumer/CMakeLists.txt ===

if (UNIX)
  # try to get architecture from compiler
  EXECUTE_PROCESS(COMMAND ${CMAKE_CXX_COMPILER} -dumpmachine COMMAND tr -d '\n' OUTPUT_VARIABLE CXX_MACHINE)
  string(REGEX REPLACE "([a-zA-Z_0-9]+).*" "\\1" ARCHITECTURE ${CXX_MACHINE})
elseif (WIN32)
  if ("${CMAKE_SIZEOF_VOID_P}" STREQUAL "4")
    set(ARCHITECTURE WIN32_i86)
  else ()
    set(ARCHITECTURE WIN64_x64)
  endif ()
endif ()

message(STATUS "Detected architecture ${ARCHITECTURE}")

install(DIRECTORY DESTINATION lib/rc_genicam_api
        DIRECTORY_PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ)

if ("${ARCHITECTURE}" STREQUAL "arm")
  install(FILES Ubuntu-14.04/armv7l/libbgapi2_gige.cti COMPONENT bin DESTINATION lib/rc_genicam_api)
  install(FILES bsysgige.xml COMPONENT bin DESTINATION lib/rc_genicam_api)
elseif ("${ARCHITECTURE}" STREQUAL "aarch64")
  install(FILES Ubuntu-14.04/arm64/libbgapi2_gige.cti COMPONENT bin DESTINATION lib/rc_genicam_api)
  install(FILES bsysgige.xml COMPONENT bin DESTINATION lib/rc_genicam_api)
elseif ("${ARCHITECTURE}" STREQUAL "x86_64")
  install(FILES Ubuntu-14.04/x86_64/libbgapi2_gige.cti COMPONENT bin DESTINATION lib/rc_genicam_api)
  install(FILES bsysgige.xml COMPONENT bin DESTINATION lib/rc_genicam_api)
elseif ("${ARCHITECTURE}" STREQUAL "i686")
  install(FILES Ubuntu-14.04/i686/libbgapi2_gige.cti COMPONENT bin DESTINATION lib/rc_genicam_api)
  install(FILES bsysgige.xml COMPONENT bin DESTINATION lib/rc_genicam_api)
elseif ("${ARCHITECTURE}" STREQUAL "WIN32_i86")
  install(FILES Win32_i86/bgapi2_gige.cti COMPONENT bin DESTINATION bin)
  install(FILES bsysgige.xml COMPONENT bin DESTINATION bin)
elseif ("${ARCHITECTURE}" STREQUAL "WIN64_x64")
  install(FILES Win64_x64/bgapi2_gige.cti COMPONENT bin DESTINATION bin)
  install(FILES bsysgige.xml COMPONENT bin DESTINATION bin)
else ()
  message(FATAL_ERROR "Unknown architecture")
endif ()

=== genicam/CMakeLists.txt ===
project(genicam CXX)

if (UNIX)
  # try to get architecture from compiler
  EXECUTE_PROCESS(COMMAND ${CMAKE_CXX_COMPILER} -dumpmachine COMMAND tr -d '\n' OUTPUT_VARIABLE CXX_MACHINE)
  string(REGEX REPLACE "([a-zA-Z_0-9]+).*" "\\1" ARCHITECTURE ${CXX_MACHINE})
elseif (WIN32)
  if ("${CMAKE_SIZEOF_VOID_P}" STREQUAL "4")
    set(ARCHITECTURE WIN32_i86)
  else ()
    set(ARCHITECTURE WIN64_x64)
  endif ()
endif ()

message(STATUS "Detected architecture ${ARCHITECTURE}")

if ("${ARCHITECTURE}" STREQUAL "arm")
  set(GENICAM_LIBRARIES
    libGCBase_gcc46_v3_1.so
    libMathParser_gcc46_v3_1.so
    libGenApi_gcc46_v3_1.so
    libNodeMapData_gcc46_v3_1.so
    liblog4cpp_gcc46_v3_1.so
    libXmlParser_gcc46_v3_1.so
    libLog_gcc46_v3_1.so
  )
  set(GENICAM_LIBRARIES_DIR ${CMAKE_CURRENT_SOURCE_DIR}/bin/Linux32_ARMhf)
elseif ("${ARCHITECTURE}" STREQUAL "aarch64")
  set(GENICAM_LIBRARIES
    libGCBase_gcc48_v3_1.so
    libMathParser_gcc48_v3_1.so
    libGenApi_gcc48_v3_1.so
    libNodeMapData_gcc48_v3_1.so
    liblog4cpp_gcc48_v3_1.so
    libXmlParser_gcc48_v3_1.so
    libLog_gcc48_v3_1.so
  )
  set(GENICAM_LIBRARIES_DIR ${CMAKE_CURRENT_SOURCE_DIR}/bin/Linux64_ARM)
elseif ("${ARCHITECTURE}" STREQUAL "i686")
  set(GENICAM_LIBRARIES
    libGCBase_gcc42_v3_1.so
    libMathParser_gcc42_v3_1.so
    libGenApi_gcc42_v3_1.so
    libNodeMapData_gcc42_v3_1.so
    liblog4cpp_gcc42_v3_1.so
    libXmlParser_gcc42_v3_1.so
    libLog_gcc42_v3_1.so
  )
  set(GENICAM_LIBRARIES_DIR ${CMAKE_CURRENT_SOURCE_DIR}/bin/Linux32_i86)
elseif ("${ARCHITECTURE}" STREQUAL "x86_64")
  set(GENICAM_LIBRARIES
    libGCBase_gcc42_v3_1.so
    libMathParser_gcc42_v3_1.so
    libGenApi_gcc42_v3_1.so
    libNodeMapData_gcc42_v3_1.so
    liblog4cpp_gcc42_v3_1.so
    libXmlParser_gcc42_v3_1.so
    libLog_gcc42_v3_1.so
  )
  set(GENICAM_LIBRARIES_DIR ${CMAKE_CURRENT_SOURCE_DIR}/bin/Linux64_x64)
elseif ("${ARCHITECTURE}" STREQUAL "WIN32_i86")
  install(FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/Win32_i86/GCBase_MD_VC120_v3_1.dll
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/Win32_i86/GenApi_MD_VC120_v3_1.dll
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/Win32_i86/Log_MD_VC120_v3_1.dll
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/Win32_i86/MathParser_MD_VC120_v3_1.dll
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/Win32_i86/msvcp120.dll
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/Win32_i86/msvcr120.dll
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/Win32_i86/NodeMapData_MD_VC120_v3_1.dll
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/Win32_i86/XmlParser_MD_VC120_v3_1.dll
	COMPONENT bin DESTINATION bin
  )
  set(GENICAM_LIBRARIES
    GCBase_MD_VC120_v3_1.lib
    GenApi_MD_VC120_v3_1.lib
  )
  set(GENICAM_LIBRARIES_DIR ${CMAKE_CURRENT_SOURCE_DIR}/library/CPP/lib/Win32_i86)
elseif ("${ARCHITECTURE}" STREQUAL "WIN64_x64")
  install(FILES
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/Win64_x64/GCBase_MD_VC120_v3_1.dll
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/Win64_x64/GenApi_MD_VC120_v3_1.dll
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/Win64_x64/Log_MD_VC120_v3_1.dll
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/Win64_x64/MathParser_MD_VC120_v3_1.dll
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/Win64_x64/msvcp120.dll
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/Win64_x64/msvcr120.dll
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/Win64_x64/NodeMapData_MD_VC120_v3_1.dll
    ${CMAKE_CURRENT_SOURCE_DIR}/bin/Win64_x64/XmlParser_MD_VC120_v3_1.dll
	COMPONENT bin DESTINATION bin
  )
  set(GENICAM_LIBRARIES
    GCBase_MD_VC120_v3_1.lib
    GenApi_MD_VC120_v3_1.lib
  )
  set(GENICAM_LIBRARIES_DIR ${CMAKE_CURRENT_SOURCE_DIR}/library/CPP/lib/Win64_x64)
else ()
  message(FATAL_ERROR "Unknown architecture")
endif ()

function(PREPEND var prefix)
  set(listVar "")
  foreach(f ${ARGN})
    list(APPEND listVar "${prefix}/${f}")
  endforeach(f)
  set(${var} "${listVar}" PARENT_SCOPE)
endfunction(PREPEND)

prepend(FILES_TO_INSTALL ${GENICAM_LIBRARIES_DIR} ${GENICAM_LIBRARIES})

install(FILES ${FILES_TO_INSTALL} COMPONENT bin DESTINATION lib)

set(GENICAM_LIBRARIES ${GENICAM_LIBRARIES} PARENT_SCOPE)
set(GENICAM_LIBRARIES_DIR ${GENICAM_LIBRARIES_DIR} PARENT_SCOPE)

# only install headers if we build and install the shared lib
if (BUILD_SHARED_LIBS)
  install(DIRECTORY library/CPP/include/ COMPONENT dev DESTINATION include/rc_genicam_api/genicam)
endif ()

=== debian/changelog ===
ros-lunar-rc-genicam-api (2.1.0-0xenial) xenial; urgency=high

  * Made System, Interface, Device and Stream objects thread safe

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 24 Jan 2019 23:00:00 -0000

ros-lunar-rc-genicam-api (2.0.4-0xenial) xenial; urgency=high

  * A buffer that is labelled to contain chunk data may also contain an image
  * Implemented fallback of open device access from readonly to control to exclusive

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 23 Jan 2019 23:00:00 -0000

ros-lunar-rc-genicam-api (2.0.3-0xenial) xenial; urgency=high

  * Improved description of some device methods
  * Under Windows, do not check install path but only current directory as default location of GenTL producer

 -- Felix Ruess <felix.ruess@roboception.de>  Tue, 08 Jan 2019 23:00:00 -0000

ros-lunar-rc-genicam-api (2.0.2-0xenial) xenial; urgency=high

  * Fixed bug in rcg::getEnum() function that may lead to a seg fault
  * Minor changes in cmake build files

 -- Felix Ruess <felix.ruess@roboception.de>  Mon, 31 Dec 2018 23:00:00 -0000

ros-lunar-rc-genicam-api (2.0.1-0xenial) xenial; urgency=high

  * Added test mode to gc_stream tool (i.e. disables saving for only testing the connection)
  * Added printing of package size to gc_stream tool
  * Added statistic to gc_stream tool
  * Removed aborting gc_stream with 'Enter' from Linux version as it causes unwanted stops in some situations
  * Minor fixes in build files.

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 20 Dec 2018 23:00:00 -0000

ros-lunar-rc-genicam-api (2.0.0-0xenial) xenial; urgency=high

  NOTE: Including multipart support required minor changes of the existing API. See readme for more
  information. Attention: The provided GenTL layer does not yet support multipart!
  * Extended Buffer and Image classes as well as the examples for handling multi-part buffers as well
    (NOTE: The provided GenTL producer does not yet support multipart!)
  * gc_stream: Using component name for storing individual images and ensuring that files are not
    overwritten
  * gc_pointcloud: Using component name for identifying images and try enabling synchronization on
    device
  * Add libs of GenICam reference implementation to external cmake dependencies of shared
    genicam_api library
  * Upgrading GenICam reference implementation to v3.1
  * Add libs of GenICam reference implementation to external dependencies of shared genicam_api
    library

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 07 Oct 2018 22:00:00 -0000

ros-lunar-rc-genicam-api (1.3.15-0xenial) xenial; urgency=high

  * Added parameter --iponly to gc_config tool

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 26 Sep 2018 22:00:00 -0000

ros-lunar-rc-genicam-api (1.3.14-0xenial) xenial; urgency=high

  * Added possibility to interrupt streaming with gc_stream by pressing 'Enter' key.
  * Undefined min/max macros in gc_pointcloud.cc on Windows to avoid compile errors

 -- Felix Ruess <felix.ruess@roboception.de>  Tue, 25 Sep 2018 22:00:00 -0000

ros-lunar-rc-genicam-api (1.3.13-0xenial) xenial; urgency=high

  * Changed output of gc_config -l to emphasize using interface and serial number as unique identifier
  * Added possibility to call a GenICam command from the command line with gc_info, gc_config and gc_stream
  * Additionally printing the internal name and display name of the GenTL producer in the gc_info tool
  * Update GEV GenTL provider from Baumer
  * Revision of readme

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 22 Aug 2018 22:00:00 -0000

ros-lunar-rc-genicam-api (1.3.12-0xenial) xenial; urgency=high

  * Getting chunk data in gc_stream and storing disparity image with all parameters for reconstruction if possible
  * Error handling in gc_stream changed by first checking for incomplete buffer and then for image present

 -- Felix Ruess <felix.ruess@roboception.de>  Tue, 17 Jul 2018 22:00:00 -0000

ros-lunar-rc-genicam-api (1.3.11-0xenial) xenial; urgency=high

  * don't install bash completion by default (doesn't work on ROS buildfarm)
  * make sure installed net_perf_check.sh script is executable

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 01 Jul 2018 22:00:00 -0000

ros-lunar-rc-genicam-api (1.3.10-0xenial) xenial; urgency=high

  * Added possibility to set GenICam parameters in gc_info too
  * Only show network summary in gc_config if called without parameters or with network related parameters
  * Corrected spelling of visard in gc_pointcloud output file name

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 27 Jun 2018 22:00:00 -0000

ros-lunar-rc-genicam-api (1.3.9-0xenial) xenial; urgency=high

  * Bash completion for UNIX and ROS
  * Relaxed synchronization in gc_pointcloud for special exposure alternate mode of rc_visard
  * Added method in image list class to request the oldest timestamp
  * Added triangulation to gc_pointcloud
  * Added parameter for output file name to gc_pointcloud
  * Fixed crashing of gc_info if enumeration does not have a value

 -- Felix Ruess <felix.ruess@roboception.de>  Thu, 14 Jun 2018 22:00:00 -0000

ros-lunar-rc-genicam-api (1.3.8-0xenial) xenial; urgency=high

  * show actually searched path instead of env var in exception if no transport layer found
  * improved README

 -- Felix Ruess <felix.ruess@roboception.de>  Tue, 17 Apr 2018 22:00:00 -0000

ros-lunar-rc-genicam-api (1.3.7-0xenial) xenial; urgency=high

  * Devices can now be discovered by serial number as well

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 08 Apr 2018 22:00:00 -0000

ros-lunar-rc-genicam-api (1.3.6-0xenial) xenial; urgency=high

  * fix path to genicam arm64 libs

 -- Felix Ruess <felix.ruess@roboception.de>  Sat, 24 Feb 2018 23:00:00 -0000

ros-lunar-rc-genicam-api (1.3.5-0xenial) xenial; urgency=high

  * add libs for arm64

 -- Felix Ruess <felix.ruess@roboception.de>  Sat, 24 Feb 2018 23:00:00 -0000

ros-lunar-rc-genicam-api (1.3.4-0xenial) xenial; urgency=high



=== debian/control ===
Source: ros-lunar-rc-genicam-api
Section: misc
Priority: extra
Maintainer: Felix Ruess <felix.ruess@roboception.de>
Build-Depends: debhelper (>= 9.0.0), cmake
Homepage: 
Standards-Version: 3.9.2

Package: ros-lunar-rc-genicam-api
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-lunar-catkin
Description: GenICam/GigE Vision Convenience Layer.
 This package combines the Roboception convenience layer for images with the GenICam reference implementation and a GigE Vision transport layer. It is a self contained package that permits configuration and image streaming of GenICam / GigE Vision 2.0 compatible cameras like the Roboception rc_visard. This package also provides some tools that can be called from the command line for discovering cameras, changing their configuration and streaming images. Although the tools are meant to be useful when working in a shell or in a script, their main purpose is to serve as example on how to use the API for reading and setting parameters, streaming and synchronizing images. See LICENSE.md for licensing terms of the different parts.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/lunar/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX="/opt/ros/lunar"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-lunar-rc-genicam-api//opt/ros/lunar/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_install
